shop_api/product/urls.py
from django.urls import path
from .views import (ProductCreateAPIView,
                    ProductsListView,
                    ProductUpdateAPIView,
                    product_get_api_view,
                    product_detail_view
                    )

app_name = 'product'
urlpatterns = [
    path('products/', ProductsListView.as_view(), name='products_list_view'),
    path('products/<int:product_id>/<title>', product_detail_view, name='product_detail_view'),
    path('api/v1/products/', product_get_api_view, name='product_get_api_view'),
    path('api/v1/products/create', ProductCreateAPIView.as_view(), name='product_create_api_view'),
    path('api/v1/products/update/<int:pk>/', ProductUpdateAPIView.as_view(), name='product_update_api_view'),
]

shop_api/product_category/urls.py
from django.urls import path
from .views import (ProductsListViewByCategory,
                    products_categories_partial_view,
                    )

app_name = 'product_category'

urlpatterns = [
    path('products/<category>/', ProductsListViewByCategory.as_view(), name='products_list_view_by_category'),
    path('products/products-categories-partial', products_categories_partial_view,
         name='products_categories_partial_view'),
]

shop_api/shop_api/urls.py
from django.conf.urls.static import static
from django.contrib import admin
from django.urls import path, include
from . import settings
from .views import home_view

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', home_view, name='home_view'),
    path('', include('product.urls', )),
    path('', include('product_category.urls', )),
]

if settings.DEBUG:
    # add root static files
    urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)
    # add root static files
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

shop_api/product/models.py
from django.db import models
from utils.os_utils import get_file_name_ext
from product_category.models import ProductCategory
from store.models import Store


def upload_image_path(instance, file_path):
    name, ext = get_file_name_ext(file_path)
    final_name = f"{instance.id}-{instance.title.replace('/','')}{ext}"
    return f"product/{final_name}"


class Product(models.Model):
    title = models.CharField(max_length=120, unique=True, verbose_name='عنوان')
    active = models.BooleanField(default=True, verbose_name='فعال')
    image = models.ImageField(upload_to=upload_image_path, null=True, blank=True, verbose_name='تصویر')
    categories = models.ManyToManyField(to=ProductCategory, verbose_name='دسته بندی ها')
    stores = models.ManyToManyField(to=Store, verbose_name='فروشگاه ها')

    class Meta:
        verbose_name = 'محصول'
        verbose_name_plural = 'محصولات'

    def __str__(self):
        return self.title

    def get_price(self):
        stores_product = StoreProduct.objects.filter(product=self)
        min_price = None
        for sp in stores_product:
            if min_price is None or sp.price < min_price:
                min_price = sp.price

        return min_price


class StoreProduct(models.Model):
    product = models.ForeignKey(Product, on_delete=models.CASCADE, verbose_name='محصول')
    store = models.ForeignKey(Store, on_delete=models.CASCADE, verbose_name='فروشگاه')
    url = models.URLField(unique=True, verbose_name='آدرس محصول در فروشگاه اینترنتی')
    price = models.DecimalField(max_digits=30, decimal_places=0, default=0.0, verbose_name='قیمت')

shop_api/product_category/models.py
from django.db import models


class ProductCategory(models.Model):
    title = models.CharField(max_length=150, unique=True, verbose_name='عنوان')

    class Meta:
        verbose_name = 'دسته بندی محصول'
        verbose_name_plural = 'دسته بندی های محصول'

    def __str__(self):
        return self.title

shop_api/store/models.py
from django.db import models
from utils.os_utils import get_file_name_ext


def upload_image_path(instance, file_path):
    name, ext = get_file_name_ext(file_path)
    final_name = f"{instance.id}-{instance.name.replace('/','')}{ext}"
    return f"store/{final_name}"


class Store(models.Model):
    name = models.CharField(max_length=150, unique=True, verbose_name='نام')
    url = models.URLField(unique=True, verbose_name='آدرس وب سایت')
    image = models.ImageField(upload_to=upload_image_path, null=True, blank=True, verbose_name='تصویر')

    class Meta:
        verbose_name = 'فروشگاه'
        verbose_name_plural = 'فروشگاه ها'

    def __str__(self):
        return self.name

shop_api/product/views.py
import json

from rest_framework import status
from rest_framework.generics import CreateAPIView, UpdateAPIView
from rest_framework.permissions import AllowAny
from django.views.generic import ListView
from .models import Product, Store
from .serializers import ProductSerializerV1
from django.shortcuts import redirect, get_object_or_404, render
from django.http import JsonResponse, HttpResponse
from django.views.decorators.csrf import csrf_exempt


class ProductCreateAPIView(CreateAPIView):
    queryset = Product.objects.all()
    serializer_class = ProductSerializerV1
    permission_classes = (AllowAny,)


class ProductUpdateAPIView(UpdateAPIView):
    queryset = Product.objects.all()
    serializer_class = ProductSerializerV1
    permission_classes = (AllowAny,)

    def perform_update(self, serializer):
        instance = serializer.instance
        data = self.request.data

        if 'category' in data.keys():
            category = serializer.get_or_create_category(category=data.pop('category'))
            if category is not None:
                instance.categories.add(category.id)

        if 'store' in data.keys():
            store = serializer.get_or_create_store(store=data.pop('store'))
            if store is not None:
                instance.stores.add(store.id)

        if 'store_product' in data.keys():
            store_product = data.pop('store_product')
            store_product['product'] = instance.id
            sp = serializer.get_or_create_store_product(store_product=store_product)
            if 'url' in store_product.keys():
                sp.url = store_product['url']

            if 'price' in store_product.keys():
                sp.price = store_product['price']
            sp.save()

        return instance


class ProductsListView(ListView):
    template_name = 'product/products-list.html'
    paginate_by = 30

    def get_queryset(self):
        return Product.objects.filter(active=True)


@csrf_exempt
def product_get_api_view(request, *args, **kwargs):
    result = HttpResponse(status=status.HTTP_400_BAD_REQUEST)

    if request.method == 'GET':
        result = redirect('product:products_list_view')

    elif request.method == 'POST':
        body = request.body.decode(encoding='utf-8')
        body = json.loads(body)
        data = {}

        if 'title' in body.keys():
            product = Product.objects.filter(title=body['title']).first()
            if product is not None:
                data["product_id"] = product.id

        result = JsonResponse(data)

    return result


def product_detail_view(request, *args, **kwargs):
    product = get_object_or_404(Product, id=kwargs['product_id'])
    all_store_product = product.storeproduct_set.all()

    stores_product = []
    for sp in all_store_product:
        store = Store.objects.filter(id=sp.store.id).first()
        stores_product.append({'store': store, 'url': sp.url, 'price': sp.price, })

    context = {
        'product': product,
        'stores_product': stores_product,
    }
    return render(request, 'product/product-details.html', context)

shop_api/product_category/views.py
from django.views.generic import ListView
from django.shortcuts import get_object_or_404, render
from .models import ProductCategory
from product.models import Product


class ProductsListViewByCategory(ListView):
    template_name = 'product/products-list.html'
    paginate_by = 30

    def get_queryset(self):
        category = self.kwargs['category']
        category = get_object_or_404(ProductCategory, title=category)

        return Product.objects.filter(categories=category, active=True)


def products_categories_partial_view(request):
    categories = ProductCategory.objects.all()

    context = {
        'categories': categories
    }

    return render(request, 'product_category/products-categories-partial.html',
                  context)

shop_api/shop_api/views.py
from django.shortcuts import redirect


def home_view(request):
    return redirect('product:products_list_view')

shop_api/store/views.py
from django.shortcuts import render

# Create your views here.

shop_api/product/templates/product/product-details.html
{% extends '_MainLayout.html' %}
{% load static %}
{% load render_partial %}

{% block content %}

    <section>
        <div class="container">
            <div class="row">

                <div class="col-sm-9 padding-right">
                    <div class="product-details"><!--product-details-->
                        <div class="col-sm-5">
                            <div class="view-product">
                                <img src="{{ product.image.url }}" alt="{{ product.title }}"/>
                                <a href="{{ product.image.url }}">
                                    <h3>بزرگنمایـی</h3>
                                </a>
                            </div>

                        </div>
                        <div class="col-sm-7">
                            <div class="product-information"><!--/product-information-->

                                <div>
                                    <h2>{{ product.title }}</h2>
                                    <p>شناسـه : {{ product.id }}</p>
                                </div>
                                <div>
									<span>
										<span>قیمت : {{ product.get_price }} تومان</span>
									</span>
                                </div>
                                <div>
                                    <p>
                                        <b>موجـودی :</b>
                                        {% if product.active %}
                                            موجود
                                        {% else %}
                                            نا موجود
                                        {% endif %}
                                    </p>
                                </div>
                                <div>
                                    {% for store_product in stores_product %}
                                        <a href="{{ store_product.url }}">
                                            <p>
                                                <img src="{{ store_product.store.image.url }}"
                                                     class="product-image-box hidden-md-and-up"
                                                     style="width: 60px; height: 60px;"
                                                     alt="{{ store_product.store.name }}"/>
                                                <span class="vendor-name">{{ store_product.store.name }}</span>
                                                <span></span>
                                                <span></span>
                                                <span></span>
                                                <span>قیمت : {{ store_product.price }} تومان</span>
                                            </p>
                                        </a>
                                    {% endfor %}
                                </div>

                            </div><!--/product-information-->
                        </div>
                    </div><!--/product-details-->

                </div>

            </div>
        </div>
    </section>
{% endblock %}

	

shop_api/product/templates/product/product-item-2-component.html
<div class="col-sm-4 pull-right">
    <div class="product-image-wrapper">
        <div class="single-products">
            <div class="productinfo text-center">
                <img src="{{ product.image.url }}" alt="{{ product.title }}" style="width: 268px;height: 250px"/>
                <h2>{{ product.get_price }} تومان</h2>
                <p>{{ product.title }}</p>
                <a href="{% url 'product:product_detail_view' product_id=product.id title=product.title %}"
                   class="btn btn-default add-to-cart"><i
                        class="fa fa-shopping-cart"></i>مشاهده محصول</a>
            </div>

        </div>
    </div>
</div>

shop_api/product/templates/product/product-item-component.html
<div class="col-sm-4 pull-right">
    <div class="product-image-wrapper">
        <div class="single-products">
            <div class="productinfo text-center">
                <img src="{{ product.image.url }}" alt="{{ product.title }}" style="width: 268px;height: 250px"/>
                <h2>{{ product.price }} تومان</h2>
                <p>{{ product.title }}</p>
            </div>
            <div class="product-overlay">
                <div class="overlay-content">
                    <h2>{{ product.price }} تومان</h2>
                    <p>{{ product.description | truncatewords:20 }}</p>
                    <a href="{{ product.get_absolute_url }}" class="btn btn-default add-to-cart"><i
                            class="fa fa-shopping-cart"></i>مشاهده محصول</a>
                </div>
            </div>
        </div>
        <div class="choose">
            <ul class="nav nav-pills nav-justified">
                <li><a href="{{ product.get_absolute_url }}" class="btn btn-default add-to-cart"><i
                        class="fa fa-shopping-cart"></i>مشاهده محصول</a></li>
                <li><a href=""><i class="fa fa-plus-square"></i>لیست علاقه مندی ها</a></li>
                <li><a href=""><i class="fa fa-plus-square"></i>مقایسه</a></li>
            </ul>
        </div>
    </div>
</div>

shop_api/product/templates/product/products-list.html
{% extends '_MainLayout.html' %}
{% load static %}
{% load render_partial %}
{% block content %}
    {% comment %}    <section id="advertisement">
        <div class="container">
            <img src="{% static 'images/shop/advertisement.jpg' %}" alt=""/>
        </div>
    </section>{% endcomment %}

    <section>
        <div class="container">
            <div class="row">
                <div class="col-sm-9 padding-right">
                    <div class="features_items"><!--features_items-->
                        <h2 class="title text-center">محصولات </h2>
                        {% for product in page_obj %}
                            {% include 'product/product-item-2-component.html' with product=product %}
                        {% endfor %}


                    </div><!--features_items-->
                    <ul class="pagination">
                        {% if page_obj.has_previous %}
                            <li><a href="?page=1">اولین</a></li>
                            <li><a href="?page={{ page_obj.previous_page_number }}">قبلی</a></li>
                        {% endif %}

                        {% for page in paginator.page_range %}
                            {% if page == page_obj.number %}
                                <li class="active"><a href="?page={{ page }}">{{ page }}</a></li>
{#                            {% else %}#}
{#                                <li><a href="?page={{ page }}">{{ page }}</a></li>#}
                            {% endif %}

                        {% endfor %}



                        {% if page_obj.has_next %}
                            <li><a href="?page={{ page_obj.next_page_number }}">بعدی</a></li>
                            <li><a href="?page={{ page_obj.paginator.num_pages }}">آخرین</a></li>
                        {% endif %}
                    </ul>
                </div>

                <div class="col-sm-3">
                    <div class="left-sidebar">
                        {% render_partial 'product_category:products_categories_partial_view' %}
                    </div>
                </div>

            </div>
        </div>
    </section>

{% endblock %}

shop_api/product_category/templates/product_category/products-categories-partial.html
<h2>دسته بندی محصولات</h2>
<div class="panel-group category-products" id="accordian"><!--category-products-->
    <div class="panel panel-default">
        <div class="panel-heading">
            <h4 class="panel-title"><a
                    href="{% url 'product:products_list_view' %}">همه</a></h4>
        </div>
    </div>
    {% for category in categories %}
        <div class="panel panel-default">
            <div class="panel-heading">
                <h4 class="panel-title"><a
                        href="{% url 'product_category:products_list_view_by_category' category=category.title %}">{{ category.title }}</a>
                </h4>
            </div>
        </div>
    {% endfor categories %}
</div><!--/category-products-->

shop_api/templates/Footer.html
{% load static %}
<footer id="footer"><!--Footer-->
		<div class="footer-Before">
			<div class="container">
				<div class="block-news">
					<div class="row">
						<h3>با عضویت در خبـرنامه ما از تخفیفات ویـژه ما با خبـر شوید ... </h3>
						<div class="searchform newslatter">
							<input type="text" placeholder="آدرس ایمیـل شما ..."/>
							<button type="submit" class="btn btn-default">
								<i class="fa fa-arrow-circle-o-left"></i>
							</button>
						</div>
					</div>
				</div>
			</div>
		</div>

		<div class="footer-top">
			<div class="container">
				<div class="row">
					<div class="col-sm-3">
						<div class="address">
							<img src="{% static 'images/home/map.png' %}" alt="" />
						</div>
					</div>
					<div class="col-sm-3">
						<div class="address">
							<img src="{% static 'images/home/map.png' %}" alt="" />
						</div>
					</div>
					<div class="col-sm-6">
						<div class="companyinfo">
							<h2><span>SHOP</span>CENTER</h2>
							<h4>درباره ما :</h4>
							<p>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده ازلورملورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد. کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد.</p>
						</div>
					</div>
				</div>
			</div>
		</div>

		<div class="footer-widget">
			<div class="container">
				<div class="row">
					<div class="col-sm-3">
						<div class="single-widget">
							<h2>Service</h2>
							<ul class="nav nav-pills nav-stacked">
								<li><a href="#">Online Help</a></li>
								<li><a href="#">Contact Us</a></li>
								<li><a href="#">Order Status</a></li>
								<li><a href="#">Change Location</a></li>
								<li><a href="#">FAQ’s</a></li>
							</ul>
						</div>
					</div>
					<div class="col-sm-3">
						<div class="single-widget">
							<h2>Quock Shop</h2>
							<ul class="nav nav-pills nav-stacked">
								<li><a href="#">T-Shirt</a></li>
								<li><a href="#">Mens</a></li>
								<li><a href="#">Womens</a></li>
								<li><a href="#">Gift Cards</a></li>
								<li><a href="#">Shoes</a></li>
							</ul>
						</div>
					</div>
					<div class="col-sm-3">
						<div class="single-widget">
							<h2>Policies</h2>
							<ul class="nav nav-pills nav-stacked">
								<li><a href="#">Terms of Use</a></li>
								<li><a href="#">Privecy Policy</a></li>
								<li><a href="#">Refund Policy</a></li>
								<li><a href="#">Billing System</a></li>
								<li><a href="#">Ticket System</a></li>
							</ul>
						</div>
					</div>
					<div class="col-sm-3">
						<div class="single-widget">
							<h2>About Shopper</h2>
							<ul class="nav nav-pills nav-stacked">
								<li><a href="#">Company Information</a></li>
								<li><a href="#">Careers</a></li>
								<li><a href="#">Store Location</a></li>
								<li><a href="#">Affillate Program</a></li>
								<li><a href="#">Copyright</a></li>
							</ul>
						</div>
					</div>
				</div>
			</div>
		</div>

		<div class="footer-bottom" style="direction: ltr !important;">
			<div class="container">
				<div class="row">
					<p class="pull-left">Copyright © 2018
						<a target="_blank" href="http://www.1614GP.ir"><b>1614Group</b></a>. All rights reserved.
					</p>
				</div>
			</div>
		</div>

	</footer><!--/Footer-->

shop_api/templates/Header.html
{% load static %}
<header id="header"><!--header-->
    <div class="header_top"><!--header_top-->
        <div class="container">
            <div class="row">
                <div class="col-sm-6">
                    <div class="contactinfo">
                        <ul class="nav nav-pills">
                            <li><a href="#"><i class="fa fa-phone"></i> 80 21 24 36 98+ </a></li>
                            <li><a href="#"><i class="fa fa-envelope"></i> info@domain.com</a></li>
                        </ul>
                    </div>
                </div>
                <div class="col-sm-6">
                    <div class="social-icons pull-right">
                        <ul class="nav navbar-nav">
                            <li><a href="#"><i class="fa fa-facebook"></i></a></li>
                            <li><a href="#"><i class="fa fa-twitter"></i></a></li>
                            <li><a href="#"><i class="fa fa-linkedin"></i></a></li>
                            <li><a href="#"><i class="fa fa-dribbble"></i></a></li>
                            <li><a href="#"><i class="fa fa-google-plus"></i></a></li>
                        </ul>
                    </div>
                </div>
            </div>
        </div>
    </div><!--/header_top-->

    <div class="header-middle"><!--header-middle-->
        <div class="container">
            <div class="row">
                <!-- <div class="col-sm-4 header-middle-menu">
                    <div class="shop-menu pull-left">
                        <ul class="nav navbar-nav">
                            <li><a href="checkout.html"><i class="fa fa-crosshairs"></i> پرداخت</a></li>
                        </ul>
                    </div>
                </div> -->

                <div class="col-sm-4" style="text-align: left;">
                    <div class="logo">
                        <a href="/"><img src="{% static 'images/home/logo.png' %}" alt="Logo"
                                         style="text-align: center;"/></a>
                    </div>
                </div>

                <div class="col-sm-8 header-middle-menu">
                    <div class="shop-menu pull-right">
                        <ul class="nav navbar-nav">
                            <li><a href="#"><i class="fa fa-user"></i> حساب کاربـری</a></li>
                            <li><a href="#"><i class="fa fa-star"></i> لیست علاقه مندی ها</a></li>
                            <li><a href="#"><i class="fa fa-lock"></i> ورود</a></li>
                            <li><a href="#"><i class="fa fa-shopping-cart"></i> سبد خریـد</a></li>
                        </ul>
                    </div>
                </div>
            </div>
        </div>
    </div><!--/header-middle-->

    <div class="header-bottom"><!--header-bottom-->
        <div class="container">
            <div class="row">

                <div class="col-sm-3">
                    <div class="search_box pull-left">
                        <input type="text" placeholder="جستـجو"/>
                    </div>
                </div>

                <div class="col-sm-9">
                    <div class="navbar-header">
                        <button type="button" class="navbar-toggle" data-toggle="collapse"
                                data-target=".navbar-collapse">
                            <span class="sr-only">Toggle navigation</span>
                            <span class="icon-bar"></span>
                            <span class="icon-bar"></span>
                            <span class="icon-bar"></span>
                        </button>
                    </div>
                    <div class="mainmenu pull-right">
                        <ul class="nav navbar-nav collapse navbar-collapse">
                            <li><a href="{% url 'home_view' %}"
                                   {% if request.resolver_match.url_name == 'home_view' %}class="active"{% endif %}>خـانه</a>
                            </li>
                            <li><a href="{% url 'product:products_list_view' %}"
                                   {% if request.resolver_match.url_name == 'products_list_view' %}class="active"{% endif %}>محصولات</a>
                            </li>
                        </ul>
                    </div>
                </div>

            </div>
        </div>
    </div><!--/header-bottom-->
</header><!--/header-->

shop_api/templates/_FooterReferences.html
{% load static %}
<script src="{% static 'js/jquery.js' %}"></script>
<script src="{% static 'js/bootstrap.min.js' %}"></script>
<script src="{% static 'js/jquery.scrollUp.min.js' %}"></script>
<script src="{% static 'js/price-range.js' %}"></script>
<script src="{% static 'js/jquery.prettyPhoto.js' %}"></script>
<script src="{% static 'js/main.js' %}"></script>

shop_api/templates/_HeaderReferences.html
{% load static %}
<link href="{% static 'css/bootstrap.min.css' %}" rel="stylesheet">
<link href="{% static 'css/font-awesome.min.css' %}" rel="stylesheet">
<link href="{% static 'css/prettyPhoto.css' %}" rel="stylesheet">
<link href="{% static 'css/price-range.css' %}" rel="stylesheet">
<link href="{% static 'css/animate.css' %}" rel="stylesheet">
<link href="{% static 'css/main.css' %}" rel="stylesheet">
<link href="{% static 'css/responsive.css' %}" rel="stylesheet">
<!--[if lt IE 9]>
    <script src="{% static 'js/html5shiv.js' %}"></script>
    <script src="{% static 'js/respond.min.js' %}"></script>
    <![endif]-->
<link rel="shortcut icon" href="{% static 'images/ico/favicon.ico' %}">
<link rel="apple-touch-icon-precomposed" sizes="144x144"
      href="{% static 'images/ico/apple-touch-icon-144-precomposed.png' %}">
<link rel="apple-touch-icon-precomposed" sizes="114x114"
      href="{% static 'images/ico/apple-touch-icon-114-precomposed.png' %}">
<link rel="apple-touch-icon-precomposed" sizes="72x72"
      href="{% static 'images/ico/apple-touch-icon-72-precomposed.png' %}">
<link rel="apple-touch-icon-precomposed" href="{% static 'images/ico/apple-touch-icon-57-precomposed.png' %}">

shop_api/templates/_MainLayout.html
{% load static %}

<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="">
    <meta name="author" content="">
    <title>صفحه اصلی | فروشگاه</title>
    {% include '_HeaderReferences.html' %}
</head><!--/head-->

<body>

{% include 'Header.html' %}

{% block content %}{% endblock %}


{% include 'Footer.html' %}
{% include '_FooterReferences.html' %}
</body>
</html>